;;;;;; psp.asm ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Declarations of a couple of important dos structures we use
; For more details, see the Ms-Dos Programmer's Reference
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;; declaration of a psp structure ;;;;;;;;;;;;;;;;;;;;;;

PSP STRUC
	pspInt20		dw ?		; Int 20h instruction
	pspNextParagraph	dw ?		; seg addr of next paragraph
				db ?		; reserved
	pspDispatcher		db 5 dup (?)	; long call to Ms-DOS
	pspTerminateVector	dd ?		; Termination addr. Int 22h
	pspControlCVector	dd ?		; CTRL-C handler (Int 23h) addr
	pspCriticalErrorVector	dd ?
				dw 11 dup(?)	; reserved
	pspEnvironment		dw ?		; seg addr of environment
				dw 23 dup(?)	; reserved
	pspFCB_1		db 11 dup(20H), 5 dup(00H) ; empty FCB1	
	pspFCB_2		db 11 dup(20H), 5 dup(00H) ; empty FCB2	
				dd ?		; reserved
;	pspCommandTail		db 128 dup(?)  	; command tail (also def DTA)
PSP		ENDS

; We are going to allocate the command tail member separately, so it is
; dropped from our declaration of the psp struc

;;;;;;;;;;;;;;;;;;;;; declaration of loadexec structure ;;;;;;;;

LOADEXEC STRUC
	leEnvironment		dw ?    ;  environment block segment
	leCommandTailOff	dw ?    ;  command tail offset
	leCommandTailSeg	dw ?	;  command tail segment
	leFCB_1			dd ?    ;  file control block 1
	leFCB_2			dd ?    ;  file control block 2
LOADEXEC ENDS

