/* bcat.c: buffered write binary file to another file */

#define VERSION "1.0"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#define USAGE "usage: bcat source_path dest_path \n"

#define MYBUFSIZ 256
static unsigned char buffer[MYBUFSIZ];


int main(int argc, char **argv){

	FILE *input,*output;
	int n=0,bin=0,bout=0;

	if(argc != 3){
		fprintf(stderr,"bcat %s",USAGE);
		return 1;
	}

	input = fopen(argv[1],"rb");
	if(!input){
		fprintf(stderr,"Could not open input file %s\n",argv[1]);
		perror("");
		return 1;
	}
	output = fopen(argv[2],"wb");
	if(!output){
		fprintf(stderr,"Could not open output file %s\n",argv[2]);
		perror("");
		return 1;
	}
	while((n = fread(buffer,1,MYBUFSIZ,input))==MYBUFSIZ){
		bin += n;
		bout += fwrite(buffer,1,n,output);
	}
	bin += n;
	bout += fwrite(buffer,1,n,output);
	fclose(input);
	fclose(output);
	printf("%d bytes in, %d bytes out\n",bin,bout);
	return 0;
}
