/* prargs.c: print out args exactly as they were handed to the program */



/* Written in an attempt to understand exactly what msdos does with
   arguments. Apparently, surrounding a string with "" will always cause
   that string to be interpreted as a single arg with the "'s being
   removed. This is the way the C run time set up by Borland C++ seems
   to parse the command tail string in the PSP.

   The DOS 3.10 Reference makes the following statement in connection with
   "Information Common to All Commands:" Commands and parameters must be
   separated by delimiters (space, comma, semicolon, equal sign, or the
   tab key.: This interpretation of the command tail must be implemented
   in the code of each command. It no longer seems to apply in DOS 6. For
   example, the DOS 6 move command recognizes whitespace and "," as
   delimiters, but not the rest. 
*/

#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char **argv)
{
	int i;

	printf("Argc = %d\n",argc);
	for(i=0;i<argc;i++)printf("Argv[%d] = %s\n", i,argv[i]);

	return 0;
}
