/* Testit.c: exercise the ramfile for testing purposes */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <io.h>

#define USAGE "usage: testit filename \n"

#define MYBUFSIZ 1024
static char buffer[MYBUFSIZ];

char message1[] = "Now is the time for all good men to come to the aid of their country.\n"; 
char message2[] = "Whether it is nobler to suffer the slings and arrows of outrageous fortune\n";  
char message3[] = "These are the times that try men's souls.\n";
char error_message[]="This was sent to stderr, fd = 2\n";
char test_message[]="This was sent to stdout\n";

int main(int argc, char **argv){

	FILE *handle;
	fpos_t my_pointer;
	int n,i,j;

	if(argc < 2){
		fprintf(stderr,"%s",USAGE);
		return 1;
	}

	handle = fopen(argv[1],"w");

	if(handle)
		{
			fprintf(stderr,"Successful open of %s for write\n",argv[1]);
			n = fwrite(message1,1,strlen(message1),handle);
			fprintf(stderr,"Wrote %d bytes\n",n);
			n = fwrite(message2,1,strlen(message2),handle);
			fprintf(stderr,"Wrote %d bytes\n",n);
			fclose(handle);
		}
	handle = fopen(argv[1],"r");
	if(handle)
		{
			fprintf(stderr,"Successful open of %s for read\n",argv[1]);
			n = fread(buffer,1,strlen(message1)+strlen(message2),handle);
			fprintf(stderr,"read %d bytes = %s",n,buffer);
			fprintf(stderr,"\nTrying to read more, this should fail\n");
			n = fread(buffer,1,MYBUFSIZ,handle);
			fprintf(stderr,"Read %d bytes\n",n);
			rewind(handle);
			fprintf(stderr,"Testing dup system call\n");
		    	i = dup(fileno(handle));    
			fprintf(stderr,"Got dup handle = %d, for descriptor %d\n",i,
				fileno(handle));
			fprintf(stderr,"Reading from duplicate handle\n");
			read(i,buffer,MYBUFSIZ);
			fprintf(stderr,"Here is what I read: \n");
			fprintf(stderr,"%s",buffer);
			rewind(handle);
			fprintf(stderr,"Now closing original file handle\n");
	                if(fclose(handle)==0)
			   fprintf(stderr,"Successful close of file handle\n"); 
			fprintf(stderr,"Can we still read from the duplicate?\n");
			buffer[0] = '\0';
			read(i,buffer,MYBUFSIZ);
			fprintf(stderr,"Here is what I read: \n");
			fprintf(stderr,"%s",buffer);

			j = 0;
			fprintf(stderr,"Let's see if we can get 2 new handles...\n");
			while(j++ <  2){
				fprintf(stderr,"New handle = %d\n",dup(i));
			}
			fprintf(stderr,"Let's dup %d  on file descriptor %d\n",1,3);
			fprintf(stderr,"dup2 returns %d\n",dup2(1,3));
			write(3,test_message,strlen(test_message)); /* should go to file */
		}
	return 0;
}
